
with ("plot.x");

// define the map
f = [a = 2.5] x -> a * x^2 * (1-x);

fig = figure.new();
N = 200;
x = zeros(N);

h = 0.001;

// sample K points between a=5.2 and a=6.6
K = 700;
A = linspace(5.2, 6.6, K);

for i = 1 : K
    a = A[i];
    f.a = a;

    // generate the sequence
    x[1] = 0.5;
    for k = 2 : N
        x[k] = f(x[k-1]);   
    end

    // plot the last 51 points of the sequence
    for j = N-50 : N
        fig.plot(a, x[j], "dot");
    end
end
fig.save("bifurcation.eps");

