
global.StepIsIn = function (x, fx, fpx, a, b) -> ok
    if fpx > 0
         ok = ((a-x) * fpx <= -fx) && ((-fx) <= (b-x) * fpx);
    elseif fpx < 0
         ok = ((a-x) * fpx >= -fx) && ((-fx) >= (b-x) * fpx);
    else
         ok = 0;
    end
end

global.GlobalNewton = function (f, fp, a, b, tolx, tolf, nEvalsMax) -> (x, fx, nEvals, aF, bF)
    fa = f(a);
    fb = f(b);
    if fa * fb > 0
       "initial interval not bracketing"
       return;
    end
    x = a;
    fx = f(x);
    fpx = fp(x);
    sprintf("%20.15f   %20.15f   %20.15f", a, x, b)
    nEvals = 1;
    while (abs(a-b) > tolx) && (abs(fx) > tolf) && ((nEvals < nEvalsMax) || (nEvals == 1))
         if StepIsIn(x, fx, fpx, a, b)
              "Newton"
              x -= fx / fpx;
         else
              "Bisection"
              x = (a+b)/2;
         end
         fx = f(x);
         fpx = fp(x);
         ++nEvals;
         if fa * fx <= 0
              b = x;
              fb = fx;
         else
              a = x;
              fa = fx;
         end
         sprintf("%20.15f   %20.15f   %20.15f", a, x, b)
    end
    aF = a;
    bF = b;
end
